//-------------------------------------------------------------------------------------
//          Copyright ? 2005-2006 META                                             
//                All Rights Reserved.                                                 
//   The file is generated by Component Wizard for QUALCOMM Mobile Platform            
// FileName:   IMetaDB.h                                                                      
// Author:    nick                          
// Date:       2006-02-22 
//Function: interface of meta database
// Log:   Author             Date             Description                              
// ------------------------------------------------------------------------------------
//       nick        2009-02-05       Initiate version                                
#ifndef __IMETADB_H__
#define __IMETADB_H__
#include "AEE.h"
#include "AEEShell.h"
#include "AEEComdef.h"
#include "AEE_OEM.h"
#include "AEEInterface.h"
#include "IAList.h"
#include "IMetaDB.h"
#include "IMetaDBRecord.h"

/*===========================================================================

                    CLASS DEFINITIONS

===========================================================================*/

#define E_METADB_TABLE_NOTOPEN 100
#define MAX_METADB_FIELD_SIZE 16


typedef enum
{
	META_DB_EVENT_NONE,
	META_DB_EVENT_INSERTED = 0x00000001,
	META_DB_EVENT_DELETED  = 0x00000002,
	META_DB_EVENT_UPDATED  = 0x00000004,
	META_DB_EVENT_ALL      = 0x00000007,
	META_DB_EVENT_MAX      = 0xFFFFFFFF
	
}MetaDBStatusMark;


// Define  interface
typedef struct IMetaDB IMetaDB;

typedef int (*MetaDBCallBack)(IMetaDB* pIMetaDB, int nRecNumber, int* pIdArray, void* pUserData); 
typedef int (*MetaDBStatusChangedFunc)(IMetaDB* pIMetaDB, MetaDBStatusMark status, void* pUserData); 

typedef struct
{
	IMetaDB* pIDB;
	ACONTEXT* pAppContext;
	void* userData;
	MetaDBStatusChangedFunc pCB;
	MetaDBStatusMark statusEventMark;
	AECHAR* pTabelName;
}DBManagerData;



AEEINTERFACE(IMetaDB)
{
	INHERIT_IQueryInterface(IMetaDB);

// database should be created once for all and the usual operation is only data management. 
// therefore the user of this interace will only need to open and close existing table. .	
	/*open table and return error if the table doesn't exist  */

	// pIMetaDBRecord contains field info such as type, fieldid, see example
	int (*Create)(IMetaDB *pIMetaDB, AECHAR* wzTableName, IMetaDBRecord* pIMetaDBRecord);

	int (*Drop)(IMetaDB *pIMetaDB);

	int (*Destroy)(IMetaDB *pIMetaDB);
	
	int (*Open)(IMetaDB *pIMetaDB, AECHAR* wzTableName);

	int (*Close)(IMetaDB *pIMetaDB);

	// the JoinRules cannot be char* because the data maybe AECHAR*
	int (*Join)(IMetaDB *pILeftDB,IMetaDB *pIRightDB, AECHAR*pJoinRules,IMetaDB **ppIJointedDB);

	int (*Query)(IMetaDB *pIMetaDB, AECHAR* pQueryFilter, MetaDBCallBack pMetaDBCallBack, int nRecNumber, void* pUserData);

	// the queryfilter can be null.
	int (*QuerySync)(IMetaDB *pIMetaDB,AECHAR* pQueryFilterRules,IAList* ppIterate);
	
	/*prepare to insert new record to table  by returning a IMetaDBRecord interface */
	int (*Insert)(IMetaDB *pIMetaDB, IMetaDBRecord* pIRecord);
	
	// Insert a record to current table with an array of metaFielddata terminated with NULL
	int (*Delete)(IMetaDB*pIMetaDB, int recID);
	
	int (*DeleteAll)(IMetaDB *pIMetaDB);

	int (*Update)(IMetaDB* pIMetaDB, int recID, IMetaDBRecord* pINewRecord);

	int (*Get)(IMetaDB* pIMetaDB, int recID, IMetaDBRecord** ppIRecord);

	int (*GetCount)(IMetaDB* pIMetaDB, AECHAR* wzFilterRule, int* nRecCount);

	//int (*GetCapacity)(IMetaDB* pThis, int* nRecCapacity);

	//int (*SetCapacity)(IMetaDB* pThis, int nRecCapacity);

	//int (*New) (IMetaDB* pIMetaDB, IMetaDBRecord** ppIRecord);

	int (*RegisterStatusChanged)(IMetaDB* pIMetaDB, MetaDBStatusChangedFunc pMetaDBStatusChangedCB,MetaDBStatusMark statusEventMark,void* pUserData);

	int (*DeleteList)(IMetaDB*pIMetaDB, IAList* piList);

	//int (*Notify)(IMetaDB* pIMetaDB, MetaDBStatusMark statusEventMark);
	int (*BeginTransaction)(IMetaDB* pIMetaDB);

	int (*EndTransaction)(IMetaDB* pIMetaDB);

	int (*AddIndex)(IMetaDB* pIMetaDB, int nFieldId);

};

struct IMetaDB
{
    const AEEVTBL(IMetaDB) *pvt;
    void* pData; 
};

#define IMetaDB_AddRef(pThis) \
	AEEGETPVTBL((pThis),IIMetaDB)->AddRef(pThis)
	
#define IMetaDB_Release(pThis) \
	AEEGETPVTBL((pThis),IMetaDB)->Release(pThis)
	
#define IMetaDB_QueryInterface(pThis,ClsID,ppInterface)  \
	AEEGETPVTBL((pThis),IMetaDB)->QueryInterface(pThis,ClsID,ppInterface)

//int (*Create)(IMetaDB *pIMetaDB, AECHAR* wzTableName, IMetaDBRecord* pIMetaDBRecord);
#define IMetaDB_Create(pThis, wzTableName, pIMetaDBRecord) \
	AEEGETPVTBL((pThis),IMetaDB)->Create(pThis, wzTableName, pIMetaDBRecord)
//int (*Drop)(IMetaDB *pIMetaDB, AECHAR* wzTableName);

#define IMetaDB_Drop(pThis) \
	AEEGETPVTBL((pThis),IMetaDB)->Drop(pThis)

// 	int (*Destroy)(IMetaDB *pIMetaDB);
#define IMetaDB_Destroy(pThis) \
	AEEGETPVTBL((pThis),IMetaDB)->Destroy(pThis)

#define IMetaDB_Open(pThis,szTableName) \
	AEEGETPVTBL((pThis),IMetaDB)->Open(pThis, szTableName)

#define IMetaDB_Close(pThis) \
	AEEGETPVTBL((pThis),IMetaDB)->Close(pThis)
		
#define IMetaDB_Join(pThis,pILeftDB,pIRightDB,ppIJoinDB) \
	AEEGETPVTBL((pThis),IMetaDB)->Join(pThis,pILeftDB,pIRightDB,ppIJoinDB)

#define IMetaDB_Query(pThis,pQueryRules,pMetaDBCallBack,nRecNumber,pUserData) \
	AEEGETPVTBL((pThis),IMetaDB)->Query(pThis,pQueryRules,pMetaDBCallBack,nRecNumber,pUserData)

#define IMetaDB_QuerySync(pThis,pQueryRules,ppIterate) \
	AEEGETPVTBL((pThis),IMetaDB)->QuerySync(pThis,pQueryRules,ppIterate)

#define IMetaDB_Insert(pThis, pMetaDBFieldData) \
	AEEGETPVTBL((pThis),IMetaDB)->Insert(pThis, pMetaDBFieldData)

#define IMetaDB_Delete(pThis,id) \
	AEEGETPVTBL((pThis),IMetaDB)->Delete(pThis,id)

#define IMetaDB_DeleteAll(pThis) \
	AEEGETPVTBL((pThis),IMetaDB)->DeleteAll(pThis)

#define IMetaDB_Update(pThis,id,pMetaDBRecord) \
	AEEGETPVTBL((pThis),IMetaDB)->Update(pThis,id,pMetaDBRecord)

#define IMetaDB_Get(pThis, pnFieldNumber, ppMetaDBFieldData)\
	AEEGETPVTBL((pThis),IMetaDB)->Get(pThis,pnFieldNumber, ppMetaDBFieldData)

#define IMetaDB_GetCount(pThis, wzFilterRule, pRecCount)\
	AEEGETPVTBL((pThis),IMetaDB)->GetCount(pThis,wzFilterRule,pRecCount)


#define IMetaDB_RegisterStatusChanged(pThis,pMetaDBStatusChangedCB,statusEventMark,pUserData)\
	AEEGETPVTBL((pThis),IMetaDB)->RegisterStatusChanged(pThis,pMetaDBStatusChangedCB,statusEventMark,pUserData)

#define IMetaDB_DeleteList(pThis,piList)\
	AEEGETPVTBL((pThis),IMetaDB)->DeleteList(pThis,piList)

#define IMetaDB_BeginTransaction(pThis)\
	AEEGETPVTBL((pThis),IMetaDB)->BeginTransaction(pThis)

#define IMetaDB_EndTransaction(pThis)\
	AEEGETPVTBL((pThis),IMetaDB)->EndTransaction(pThis)

#define IMetaDB_AddIndex(pThis, nFieldId)\
	AEEGETPVTBL((pThis),IMetaDB)->AddIndex(pThis, nFieldId)

#endif



/*
#define IMetaDB_GetCapacity(pThis, pRecCapacity)\
	AEEGETPVTBL((pThis),IMetaDB)->GetCapacity(pThis,pRecCapacity)

#define IMetaDB_SetCapacity(pThis, nRecCapacity)\
	AEEGETPVTBL((pThis),IMetaDB)->SetCapacity(pThis,nRecCapacity)
*/
