
//-------------------------------------------------------------------------------------
//          Copyright ? 2005-2006 META                                             
//                All Rights Reserved.                                                 
//   The file is generated by Component Wizard for QUALCOMM Mobile Platform            
// FileName:   CMetaDB.c                                                                      
// Author:    nick                          
// Date:       2006-02-22 
//Function: implement IMetaDB interface
// Log:   Author             Date             Description                              
// ------------------------------------------------------------------------------------
//       nick        2009-02-06       Initiate version                                
//-------------------------------------------------------------------------------------
#include "AEEShell.h"
#include "AEE_OEM.h"
#include "AEE_OEMComdef.h"

#include "AEEStdLib.h"
#include "AEEBase.h"
#include "AEESQL.h"
#include "MetaClassID.h"
#include "MetaMemory.h"

#include "AEE_OEMDispatch.h"
#include "MetaCommonMacro.h"
#include "MetaTrace.h"
#include "IAList.h"
#include "AEESQL.h"
#include "IMetaDB.h"
#include "IMetaDBRecord.h"
#include "AEECLSID_SQLMGR.bid"


#ifndef AEE_SIMULATOR
#if 0
#include "hs_mb6250.h"
#else
#include "hs_mb6100.h"//platform qsc60x0
#endif
#endif

//////////////////////////////////////////////////////////////////////////

//#define Max_Meta_Table_Length 20
#define Max_Meta_Sql_Text_Length 400
#define Default_Record_Capacity 10

static AECHAR* MetaDB_Type_Name[]=
{
	L"text",
	L"text",
	L"integer",
	L"integer",
	L"text",
	L"blob",
	L"time"
};

typedef enum
{
	MetaDB_Pack_Name_Enum,
	MetaDB_Pack_WildCard_Enum,
	MetaDB_Pack_Value_Enum, 
	MetaDB_Pack_Assignment_Enum,
	MetaDB_Pack_Name_Type_Enum
}MetaDB_Pack_Type_Enum;



typedef struct CMetaDB
{
	uint32 nRefs;
	IShell *pIShell;
	IMetaDB myIMetaDB;	
	ISQL*  piSQL;	//should store the ISQL *
	ISQLMgr* piSQLMgr;
	ISQLStmt* piStmt;
	AECHAR* wzTableName;
	AECHAR* wzSQLText;
	//int  nRecCapacity;
	//int  nRecNumber;
	//IMetaDBRecord* ppiRecord[Default_Record_Capacity];
	//int nFieldNumber;
	//TMetaDBFieldDesc* pMetaDBFieldDesc; 
	IAList* piCallbackList;
}CMetaDB;

// pCMetaDB must be created statically like singleton




// singleton and should not be freed with meta_destructor ?????
static ISQLMgr* gpiSQLMgr = NULL;
static IAList* gpiDBCallBackList = NULL;
//static DBManagerData* gpDBManagerData = NULL;
/*===========================================================================

                    DEFINITIONS AND CONSTANTS

===========================================================================*/

static uint32 CMetaDB_IBase_AddRef(IMetaDB* pIMetaDB);
static uint32 CMetaDB_IBase_Release(IMetaDB* pIMetaDB);
static int CMetaDB_IBase_QueryInterface(IMetaDB* pIMetaDB, AEECLSID ClsID, void** ppInterface);

static int CMetaDB_IMetaDB_Create(IMetaDB *pIMetaDB, AECHAR* wzTableName, IMetaDBRecord* pIMetaDBRecord);

static int CMetaDB_IMetaDB_Drop(IMetaDB *pIMetaDB);

static int CMetaDB_IMetaDB_Destroy(IMetaDB *pIMetaDB);

static int CMetaDB_IMetaDB_Open(IMetaDB *pIMetaDB, AECHAR* wzTableName);

static int CMetaDB_IMetaDB_Close(IMetaDB *pIMetaDB);

static int CMetaDB_IMetaDB_Join(IMetaDB *pILeftDB,IMetaDB *pIRightDB, AECHAR*pJoinRules,IMetaDB **ppIJointedDB);

static int CMetaDB_IMetaDB_Query(IMetaDB *pIMetaDB, AECHAR*pQueryRules, MetaDBCallBack pMetaDBCallBack, int nRecNumber, void* pUserData);

static int CMetaDB_IMetaDB_QuerySync(IMetaDB *pIMetaDB, AECHAR*pQueryRules, IAList* pIterate);

static int CMetaDB_IMetaDB_Insert(IMetaDB *pIMetaDB, IMetaDBRecord* pIMetaDBRecord);

static int CMetaDB_IMetaDB_Delete(IMetaDB *pIMetaDB,int id);

static int CMetaDB_IMetaDB_DeleteAll(IMetaDB *pIMetaDB);

static int CMetaDB_IMetaDB_Update(IMetaDB *pIMetaDB,int id, IMetaDBRecord* pIMetaDBRecord);

static int CMetaDB_IMetaDB_Get(IMetaDB *pIMetaDB, int rowId, IMetaDBRecord** ppIMetaDBRecord);

static int CMetaDB_IMetaDB_GetCount(IMetaDB* pIMetaDB, AECHAR* wzFilterRule, int* nRecCount);

/*
static int CMetaDB_IMetaDB_GetCapacity(IMetaDB* pIMetaDB, int* pRecCount);

static int CMetaDB_IMetaDB_SetCapacity(IMetaDB* pIMetaDB, int nRecCount);
*/

static int CMetaDB_IMetaDB_RegisterStatusChanged(IMetaDB *pIMetaDB, MetaDBStatusChangedFunc pMetaDBStatusChangedCB,MetaDBStatusMark statusEventMark,void* pUserData);

static int CMetaDB_IMetaDB_DeleteList(IMetaDB*pIMetaDB, IAList* piList);

static int CMetaDB_IMetaDB_BeginTransaction(IMetaDB *pIMetaDB);

static int CMetaDB_IMetaDB_EndTransaction(IMetaDB *pIMetaDB);

static int CMetaDB_IMetaDB_AddIndex(IMetaDB *pIMetaDB, int nFieldId);

static int CMetaDB_IMetaDB_New(IMetaDB *pIMetaDB, IMetaDBRecord** ppMetaDBRecord);

static CMetaDB*  CMetaDB_Constructor(IShell* pIShell);

static void CMetaDB_Destructor(CMetaDB* pThis);

//////////////////////////////////////////////////////////////////////////
// TODO: Add user code at here                                            
//////////////////////////////////////////////////////////////////////////

static uint32 CMetaDB_IBase_AddRef(IMetaDB* pIMetaDB)
{
    CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;

    pThis->nRefs++;

    return pThis->nRefs;
}

static uint32 CMetaDB_IBase_Release(IMetaDB* pIMetaDB)
{
    CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;

    pThis->nRefs--;
    if(pThis->nRefs == 0)
    {
        CMetaDB_Destructor(pThis);
    }

    return 0;
}

static int CMetaDB_IBase_QueryInterface(IMetaDB* pIMetaDB, AEECLSID ClsID, void** ppInterface)
{
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	int result = EUNSUPPORTED;
	if(ClsID == META_CLSID_DATABASE) //NEED DEFINITION
	{
		IBASE_COPY_IPTR(*ppInterface, pIMetaDB);
		result = SUCCESS;
	}
    return result;
}

static const struct AEEVTBL(IMetaDB) gIMetaDBFuncs = 
{
    CMetaDB_IBase_AddRef,
    CMetaDB_IBase_Release,
    CMetaDB_IBase_QueryInterface,
    CMetaDB_IMetaDB_Create,
	CMetaDB_IMetaDB_Drop,
    CMetaDB_IMetaDB_Destroy,
    CMetaDB_IMetaDB_Open,
    CMetaDB_IMetaDB_Close,
    CMetaDB_IMetaDB_Join,
    CMetaDB_IMetaDB_Query,
    CMetaDB_IMetaDB_QuerySync,
    CMetaDB_IMetaDB_Insert,    
    CMetaDB_IMetaDB_Delete,
    CMetaDB_IMetaDB_DeleteAll,
    CMetaDB_IMetaDB_Update,
    CMetaDB_IMetaDB_Get,
	CMetaDB_IMetaDB_GetCount,
	//CMetaDB_IMetaDB_New,
	CMetaDB_IMetaDB_RegisterStatusChanged,
	CMetaDB_IMetaDB_DeleteList,
	CMetaDB_IMetaDB_BeginTransaction,
	CMetaDB_IMetaDB_EndTransaction,
	CMetaDB_IMetaDB_AddIndex,
};


static AECHAR* CMetaDB_GetTableName(IMetaDB* pIMetaDB)
{
	CMetaDB* pThis = (CMetaDB*)pIMetaDB->pData;
	return pThis->wzTableName;
}

// also we must guarantee it is the same table!!!
static int MetaDB_GetCBPointer(IMetaDB* pIMetaDB, IAList* piCBList, DBManagerData** ppDBManagerData)
{
	int result = EFAILED;
	ushort i;
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	ushort nNodeNumber = 0;
	ACONTEXT* appContext;
	appContext = AEE_GetAppContext();
	if (IAList_GetSize(piCBList, &nNodeNumber) == SUCCESS)
	{
		for (i = 0;  i < nNodeNumber;  i++)
		{
			if (IAList_Get(piCBList, i, (TAListElement**)ppDBManagerData)== SUCCESS)
			{
				if ((*ppDBManagerData)->pAppContext == appContext && (*ppDBManagerData)->pIDB == pIMetaDB)
				{
					if (WSTRICMP((*ppDBManagerData)->pTabelName, pThis->wzTableName) == 0)
					{
						result = SUCCESS;
					}
				}
			}
		}
	}
	return result;
}

//	META_DB_EVENT_INSERTED = 0x00000001,
//	META_DB_EVENT_DELETED = 0x00000002,
//	META_DB_EVENT_UPDATED = 0x00000004,
static int CMetaDB_Notify_Event(IMetaDB* pIMetaDB, MetaDBStatusMark eventType)
{
	int result = EFAILED;
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	DBManagerData* pDBManagerData = NULL;
	ushort nNodeNumber = 0;
	ushort i;
	ACONTEXT* appContext;

	if (gpiDBCallBackList == NULL || pThis == NULL || pThis->wzTableName == NULL)
	{
		return result;
	}

	appContext = AEE_GetAppContext();
	if ((result = IAList_GetSize(gpiDBCallBackList, &nNodeNumber)) == SUCCESS)
	{
		for (i = 0;  i < nNodeNumber;  i++)
		{
			if ((result = IAList_Get(gpiDBCallBackList, i, (TAListElement**)&pDBManagerData))== SUCCESS)
			{
				// be careful, don't notify yourself!!!
				if (pIMetaDB != pDBManagerData->pIDB && (eventType&pDBManagerData->statusEventMark) &&  pDBManagerData->pAppContext == appContext && pDBManagerData->pCB != NULL && pDBManagerData->pTabelName != NULL)
				{									
					if (WSTRICMP(pDBManagerData->pTabelName, pThis->wzTableName) == 0)
					{						
						pDBManagerData->pCB(pDBManagerData->pIDB, eventType, pDBManagerData->userData);					
					}						
				}
			}
		}
	}
	return result;
}

static int MetaDB_RemoveCBPointer(IMetaDB* pIMetaDB, IAList* piCBList)
{
	ushort i;
	int result = EFAILED;
	DBManagerData* pDBManagerData;
	ushort nNodeNumber = 0;
	ACONTEXT* appContext;
	appContext = AEE_GetAppContext();
	if ((result = IAList_GetSize(piCBList, &nNodeNumber)) == SUCCESS)
	{
		for (i = 0;  i < nNodeNumber;  i++)
		{
			if ((result = IAList_Get(piCBList, i, (TAListElement**)&pDBManagerData)) == SUCCESS)
			{
				if ((pDBManagerData)->pAppContext == appContext && (pDBManagerData)->pIDB == pIMetaDB)
				{
					if ((result = IAList_Remove(piCBList, i)) == SUCCESS)
					{
						//don't forget to release memory!
						MetaFree(&pDBManagerData);						
					}
				}
			}
		}
	}
	return result;
}


static int MetaDB_Pack_String(AECHAR* buffer, IMetaDBRecord* pIMetaDBRecord, MetaDB_Pack_Type_Enum packType)
{
	int size = 0;
	ushort i = 0;
	ushort nFieldNumber;
	AECHAR* wzPtr;
	TMetaDBRecordData* pMetaDBRecordData;

	if (IMetaDBRecord_GetFieldCount(pIMetaDBRecord, &nFieldNumber)== SUCCESS)
	{
		size += WSTRLEN(buffer);
		wzPtr = buffer + size;
		if (size >= Max_Meta_Sql_Text_Length)
		{
			return -1;
		}
		switch (packType)
		{
		case MetaDB_Pack_Name_Enum:
			if (IMetaDBRecord_GetFieldPointerByIndex(pIMetaDBRecord, 0, &pMetaDBRecordData) == SUCCESS)
			{
				WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L"field%d", pMetaDBRecordData->fieldDesc.fieldID);	
			}
			break;
		case MetaDB_Pack_WildCard_Enum:
			// nick: ?# must starting from 1, 0 is reserved by QUALCOMM !!!!
			WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L"?%d", i + 1);	
			break;

			////////////////////////////////////// we need to map the sqldatatype to sqlcoldatatype
		case MetaDB_Pack_Name_Type_Enum:
			if (IMetaDBRecord_GetFieldPointerByIndex(pIMetaDBRecord, 0, &pMetaDBRecordData) == SUCCESS)
			{
				WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L"id integer primary key, field%d %s", pMetaDBRecordData->fieldDesc.fieldID, 
					MetaDB_Type_Name[pMetaDBRecordData->fieldDesc.type]);
			}
			break;
		case MetaDB_Pack_Assignment_Enum:
			if (IMetaDBRecord_GetFieldPointerByIndex(pIMetaDBRecord, 0, &pMetaDBRecordData)== SUCCESS)
			{
				WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L"field%d=?1", pMetaDBRecordData->fieldDesc.fieldID);	
			}
			break;		
		//case MetaDB_Pack_Select_Name_Enum:			
		}
		
		for (i = 1; i < nFieldNumber; i ++)		
		{		
			size += WSTRLEN(wzPtr);		
			if (size >= Max_Meta_Sql_Text_Length)
			{
				return -1;
			}
			wzPtr = buffer + size;

			switch (packType)
			{		
			case MetaDB_Pack_Name_Enum:
				if (IMetaDBRecord_GetFieldPointerByIndex(pIMetaDBRecord, i, &pMetaDBRecordData)== SUCCESS)
				{
					WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L",field%d", pMetaDBRecordData->fieldDesc.fieldID);	
				}
				break;
			case MetaDB_Pack_WildCard_Enum:
				WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L",?%d", i+1); 
				break;
			case MetaDB_Pack_Name_Type_Enum:	
				if (IMetaDBRecord_GetFieldPointerByIndex(pIMetaDBRecord, i, &pMetaDBRecordData)== SUCCESS)
				{
					WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L",field%d %s", pMetaDBRecordData->fieldDesc.fieldID, 
					MetaDB_Type_Name[pMetaDBRecordData->fieldDesc.type]);
				}
				break;
			case MetaDB_Pack_Assignment_Enum:
				if (IMetaDBRecord_GetFieldPointerByIndex(pIMetaDBRecord, i, &pMetaDBRecordData)== SUCCESS)
				{
					WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - size, L",field%d=?%d", pMetaDBRecordData->fieldDesc.fieldID, i+1);	
				}
				break;		
			}				
		}
	}
	return i;
}


static int MetaDB_Bind_Data(CMetaDB* pThis, IMetaDBRecord* pIMetaDBRecord)
{
	int nErr;
	ushort i;
	ushort nFieldNumber;
	TMetaDBRecordData* pMetaDBRecordData;

	if (pIMetaDBRecord == NULL)
	{
		return EFAILED;
	}
	if (IMetaDBRecord_GetFieldCount(pIMetaDBRecord, &nFieldNumber) == SUCCESS)
	{	
		for (i = 0; i < nFieldNumber; i ++)
		{
			if (IMetaDBRecord_GetFieldPointerByIndex(pIMetaDBRecord, i, &pMetaDBRecordData)== SUCCESS)
			{
				switch(pMetaDBRecordData->fieldDesc.type)
				{
				case META_FIELD_TEXT:			
					nErr = ISQLSTMT_BindText(pThis->piStmt, i+1, (char*)pMetaDBRecordData->pData, pMetaDBRecordData->len, NULL);
					break;
				case META_FIELD_WTEXT:
							
					nErr = ISQLSTMT_BindWText(pThis->piStmt, i+1,(AECHAR*)pMetaDBRecordData->pData, pMetaDBRecordData->len, NULL);
					break;
				case META_FIELD_INT32:
					nErr = ISQLSTMT_BindInt(pThis->piStmt, i+1, *((int*)pMetaDBRecordData->pData));
					break;
				case META_FIELD_TIME:
				case META_FIELD_INT64:
					nErr = ISQLSTMT_BindInt64(pThis->piStmt, i+1, *((int64*)pMetaDBRecordData->pData));
					break;			
				case META_FIELD_BINARY:
					nErr = ISQLSTMT_BindBlob(pThis->piStmt,i+1, pMetaDBRecordData->pData, pMetaDBRecordData->len, NULL);
					break;
				case META_FIELD_NULL:
					nErr = ISQLSTMT_BindNull(pThis->piStmt, i+1);
					break;		
				}
				if (nErr != SUCCESS)
				{
					return nErr;
				}
			}
		}
	}
	return SUCCESS;
}	


//////////////////////////////////////////////////////////////////////////
// CMetaDB_New() to create component instance                                  
//////////////////////////////////////////////////////////////////////////
int CMetaDB_New(IShell *pIShell, AEECLSID ClsID,void** ppInterface)
{
	int result = SUCCESS;
	CMetaDB* pThis; 
	IMetaDB* pIMetaDB = NULL;
	if(pIShell == NULL || ppInterface == NULL)
	{
		return EBADPARM;
	}

	// MAYBE WE SUPPORT OTHER INTERFACE LATER.
	if(ClsID != META_CLSID_DATABASE)
	{
		return EUNSUPPORTED;
	}

	pThis = CMetaDB_Constructor(pIShell);
	if (!pThis)
	{
		result =  ENOMEMORY;
		goto Exit;
	}
	
	pIMetaDB = &pThis->myIMetaDB;
	// MAYBE WE SUPPORT OTHER INTERFACE LATER.
	
	result = CMetaDB_IBase_QueryInterface(pIMetaDB, ClsID, ppInterface);
	if( result != SUCCESS)
	{
		CMetaDB_Destructor(pThis);
		goto Exit;
	}
	Exit:
	return result;	
}

static CMetaDB* CMetaDB_Constructor(IShell* pIShell)
{
	CMetaDB* pThis = NULL;

	int result= EFAILED;	

	if ((pThis = (CMetaDB*)MetaAlloc(sizeof(CMetaDB)))!= NULL)
	{	
		pThis->wzTableName = NULL;

		pThis->wzSQLText = NULL;

		pThis->nRefs = 0;
		ISHELL_AddRef(pIShell);
		pThis->pIShell = pIShell;
		pThis->piSQL  = NULL;
		pThis->piStmt = NULL;
		pThis->myIMetaDB.pvt = &gIMetaDBFuncs;
		pThis->myIMetaDB.pData = (void*)pThis;
		pThis->piCallbackList = NULL;
		pThis->piSQLMgr = NULL;

		if ((result = ISHELL_CreateInstance(pIShell, AEECLSID_SQLMGR, (void**)&pThis->piSQLMgr)) == SUCCESS)
		{
			//this is exactly similar to above, the only failing case for singleton is 1)first time 2) and creating failed.
			if (gpiDBCallBackList != NULL || (SUCCESS == ISHELL_CreateInstance(pIShell, META_CLSID_ALIST, (void**)&gpiDBCallBackList)))
			{			
				IBASE_COPY_IPTR(pThis->piCallbackList, gpiDBCallBackList);	
				if ((pThis->wzSQLText = (AECHAR*) MetaAlloc((uint32)Max_Meta_Sql_Text_Length*sizeof(AECHAR)))!= NULL)
				
				{
					pThis->wzSQLText[0] = L'\0';					
					result = SUCCESS;
				}		
			}
		}	
	}
	if (result != SUCCESS)
	{
		if (pThis)
		{
			CMetaDB_Destructor(pThis);
			pThis = NULL;
		}
	}
	return pThis;
    //////////////////////////////////////////////////////////////////////////
}


static void CMetaDB_Destructor(CMetaDB* pThis)
{
    //////////////////////////////////////////////////////////////////////////
    // TODO: Add user destructor code here                                    
    //////////////////////////////////////////////////////////////////////////   
	int result = 0;
	IBASE_RELEASE_IPTR(pThis->piSQL); //release ISQLMgr .

	IBASE_RELEASE_IPTR(pThis->piStmt); //release ISQLMgr .
	
	ISHELL_Release(pThis->pIShell);

	IBASE_RELEASE_IPTR(pThis->piSQLMgr); //release ISQLMgr ...	

	IBASE_RELEASE_IPTR(pThis->piCallbackList);

	if (pThis->wzSQLText)
	{
		MetaFree(&pThis->wzSQLText);
		pThis->wzSQLText = NULL;
	}
	if (pThis->wzTableName)
	{
		MetaFree(&pThis->wzTableName);
		pThis->wzTableName = NULL;
	}
	MetaFree(&pThis);	
}


static int CMetaDB_Init(IMetaDB *pIMetaDB, AECHAR* wzTableName)
{
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;	
	DBManagerData* pDBManagerData = NULL;
	int result = EFAILED;
	
	if (pThis)
	{	
		IBASE_RELEASE_IPTR(pThis->piSQL);
		IBASE_RELEASE_IPTR(pThis->piStmt);				
			
		//we will hardcode the database name here		
		if  ((result = ISQLMGR_Open(pThis->piSQLMgr,"fs:/MetaDBFile", &pThis->piSQL, SQLF_WIDE)) == SUCCESS)
		{				
			//need to test if malloc succeeds
			result = EFAILED;
			if (pThis->wzTableName)
			{
				MetaFree(&pThis->wzTableName);
				pThis->wzTableName = NULL;
			}
			if ( pThis->wzTableName =(AECHAR*) MetaAlloc((WSTRLEN(wzTableName) + 1)*sizeof(AECHAR)))
			{
				WSTRCPY(pThis->wzTableName, wzTableName);
				result = SUCCESS;
			}						
		}	
	
		if (SUCCESS != MetaDB_GetCBPointer(pIMetaDB, gpiDBCallBackList, &pDBManagerData))
		{	
			pDBManagerData = MetaAlloc(sizeof(DBManagerData));
		}
		if (pDBManagerData)
		{
			pDBManagerData->pAppContext = AEE_GetAppContext();
			pDBManagerData->pIDB = pIMetaDB;
			pDBManagerData->pTabelName = pThis->wzTableName;
			pDBManagerData->pCB = NULL;
		}
		else
		{
			result = EFAILED;
		}			
	}
	return result;
}


int WSTRTOUL(AECHAR* src)
{
	char buffer[MAX_METADB_FIELD_SIZE];
	if (WSTRTOSTR(src, buffer, MAX_METADB_FIELD_SIZE))
	{
		return STRTOUL(buffer, NULL, 10);	
	}
	return 0;
}
	
	

//ISQLSTMT_ColumnCount()


TMetaFieldTypeEnum colDataType2metaDataType(AEESQLColDataType sqlType)
{
	TMetaFieldTypeEnum result;
	switch (sqlType)
	{
	case AEESQL_COL_DT_INTEGER:
		result =  META_FIELD_INT32;
		break;
	case AEESQL_COL_DT_FLOAT:
		result = META_FIELD_INT32;
		break;
	case  AEESQL_COL_DT_TEXT:
		result = META_FIELD_WTEXT;
		break;
	case AEESQL_COL_DT_BLOB:
		result = META_FIELD_BINARY;
		break;
	case AEESQL_COL_DT_NULL:
		result = META_FIELD_NULL;
		break;
	// ...
	}
	return result;
}
/*


// Data types
typedef enum {
   AEESQL_DT_TEXT,
   AEESQL_DT_WTEXT,
   AEESQL_DT_INT,
   AEESQL_DT_DOUBLE,
   AEESQL_DT_BLOB,
   AEESQL_DT_NULL,
   AEESQL_DT_INT64
} AEESQLDataType;
*/

AEESQLColDataType sqlDataType2sqlColDataType(AEESQLDataType dataType)
{
	switch (dataType)
	{
	case AEESQL_DT_TEXT:
	case AEESQL_DT_WTEXT:
		return AEESQL_COL_DT_TEXT;
	case AEESQL_DT_INT:
	case AEESQL_DT_INT64:
		return AEESQL_COL_DT_INTEGER;
	case AEESQL_DT_DOUBLE:
		return AEESQL_COL_DT_FLOAT;
	case AEESQL_DT_BLOB:
		return AEESQL_COL_DT_BLOB;
	case AEESQL_DT_NULL:
		return AEESQL_COL_DT_NULL;
	}
}

AEESQLDataType  sqlColDataType2sqlDataType(AEESQLColDataType colDataType)
{
	switch (colDataType)
	{
	case AEESQL_COL_DT_TEXT:
		return 	AEESQL_DT_WTEXT;

	case  AEESQL_COL_DT_INTEGER:
		return 	AEESQL_DT_INT;

	case AEESQL_COL_DT_FLOAT:
		return AEESQL_DT_DOUBLE;

	case AEESQL_COL_DT_BLOB:
		return AEESQL_DT_BLOB;
	case AEESQL_COL_DT_NULL:
		return AEESQL_DT_NULL;
	}
}
	

/*
typedef enum
{
	META_FIELD_TEXT  = 0,
	META_FIELD_WTEXT = 1,
	META_FIELD_INT32 = 2,
	META_FIELD_INT64 = 3,
	META_FIELD_NULL  = 4,
	META_FIELD_BINARY= 5,
	META_FIELD_TIME  = 6
}TMetaFieldTypeEnum;
typedef enum {
   AEESQL_COL_DT_INTEGER = 1,
   AEESQL_COL_DT_FLOAT,
   AEESQL_COL_DT_TEXT,
   AEESQL_COL_DT_BLOB,
   AEESQL_COL_DT_NULL
} AEESQLColDataType;
*/

int MetaDB_Get_Column_Data(ISQLStmt* piSqlStmt, int columnIndex, TMetaDBRecordData** ppRecordData)
{
	AEESQLColDataType colType;
	//AEESQLDataType   dataType;
	TMetaFieldTypeEnum metaType;
	int result = EFAILED;
	int recordSize = 0, dataSize;
	int myInt;
	AECHAR* pwText;
	const AECHAR *pwzStr;
	char* myPtr;

	colType = ISQLSTMT_ColumnDataType(piSqlStmt, columnIndex);	

	metaType = colDataType2metaDataType(colType);
	dataSize = ISQLSTMT_ColumnSize(piSqlStmt, columnIndex);
	switch (metaType)
	{
	case META_FIELD_INT32:
		recordSize = META_DBRECORD_SIZE + sizeof(int32);
		dataSize = sizeof(int32);
		result = ISQLSTMT_GetColumnInt(piSqlStmt, columnIndex, &myInt);
		break;
	case META_FIELD_WTEXT:
		dataSize *= sizeof(AECHAR);
		recordSize = META_DBRECORD_SIZE + dataSize;
		result = ISQLSTMT_GetColumnWText(piSqlStmt, columnIndex, &pwText);
		break;
	case META_FIELD_BINARY:
		recordSize = META_DBRECORD_SIZE + dataSize;
		result = ISQLSTMT_GetColumnBlob(piSqlStmt, columnIndex, &myPtr);
		break;
	}
	if (result == SUCCESS)
	{
		if ((*ppRecordData = MetaAlloc(recordSize))!= NULL)
		{
			(*ppRecordData)->fieldDesc.type = metaType;
			(*ppRecordData)->len = dataSize;
			pwzStr = ISQLSTMT_WColumnName(piSqlStmt, columnIndex);
			//field name is "field#"   length of "field" is 5
			(*ppRecordData)->fieldDesc.fieldID = WSTRTOUL((AECHAR*)(pwzStr + 5));

			switch (metaType)
			{
			case META_FIELD_INT32:
				MEMCPY(&(*ppRecordData)->pData, &myInt, sizeof(int32));
				break;
			case META_FIELD_WTEXT:
				MEMCPY(&(*ppRecordData)->pData, pwText, dataSize);
				break;
			case META_FIELD_BINARY:
				MEMCPY(&(*ppRecordData)->pData, myPtr, dataSize);
				break;
			}
		}
	}
	return result;
}		
	
static int CMetaDB_Prepare_Result_For_int(CMetaDB* pThis, int* nRecCount)
{
	int result = EFAILED, nErr;
	int len;
	const AECHAR* pszPtr;
	
	len = WSTRLEN(pThis->wzSQLText)* sizeof(AECHAR);
	if (SUCCESS == ISQL_WPrepare(pThis->piSQL, pThis->wzSQLText, len, &pThis->piStmt, &pszPtr))
	{	
		nErr = ISQLSTMT_Step(pThis->piStmt);
	
		if (nErr == SQL_ROW)
		{	
			result = ISQLSTMT_GetColumnInt(pThis->piStmt, 0, nRecCount);		
		}
		IBASE_RELEASE_IPTR(pThis->piStmt);
	}
	return result;
}
			
static int CMetaDB_Prepare_Result_For_One_Row(CMetaDB* pThis, IMetaDBRecord* pIMetaDBRecord)
{
	int result = EFAILED, nErr;
	int columnCount, i, len;
	TMetaDBRecordData* pRecordData;
	const AECHAR* pszPtr;
	
	len = WSTRLEN(pThis->wzSQLText)* sizeof(AECHAR);
	if (SUCCESS == ISQL_WPrepare(pThis->piSQL, pThis->wzSQLText, len, &pThis->piStmt, &pszPtr))
	{		
		if (pIMetaDBRecord)
		{					
			nErr = ISQLSTMT_Step(pThis->piStmt);
		
			if (nErr == SQL_ROW)
			{
				columnCount = ISQLSTMT_ColumnCount(pThis->piStmt);
				// we assume "id" is at index of 0
				for (i = 1; i< columnCount; i ++)
				{
					if ((result = MetaDB_Get_Column_Data(pThis->piStmt, i, &pRecordData)) != SUCCESS)
					{
						break;
					}
					else
					{
						if ((result = IMetaDBRecord_InsertField(pIMetaDBRecord, pRecordData))!= SUCCESS)
						{
							break;
						}
					}
				}
			}
		}
		IBASE_RELEASE_IPTR(pThis->piStmt);
	}
	return result;
}
		
static int CMetaDB_Prepare_Result_With_Callback(CMetaDB* pThis, MetaDBCallBack pMetaDBCallback, int nRecNumber, void* pUserData)
{
	int result = EFAILED, nErr;
	int id;
	int nCounter;
	int len;
	const AECHAR* pszPtr;
	int* pIdArray = NULL;
	IMetaDB* piMetaDB = &pThis->myIMetaDB;

	if (nRecNumber <= 0 || pMetaDBCallback == NULL || pThis == NULL)
	{
		return result;
	}

	if (pThis->wzSQLText)
	{
		len = WSTRLEN(pThis->wzSQLText) * sizeof(AECHAR);

		if (SUCCESS == (result= ISQL_WPrepare(pThis->piSQL, pThis->wzSQLText, len, &pThis->piStmt, &pszPtr)))
		{		
			if ((pIdArray = (int*)MetaAlloc(sizeof(int)*nRecNumber))!= NULL)
			{		
				nCounter = 0;
				nErr = ISQLSTMT_Step(pThis->piStmt);
		
				while (nErr == SQL_ROW)
				{			
					result = SUCCESS;
					if (ISQLSTMT_GetColumnInt(pThis->piStmt, 0, &id) == SUCCESS)
					{
						pIdArray[nCounter] = id;
						nCounter ++;
						if (nCounter == nRecNumber)
						{
							if ((result = pMetaDBCallback(piMetaDB, nCounter, pIdArray, pUserData))!= SUCCESS)
							{
								result = SQL_ABORT;
								break;
							}
							nCounter = 0;
						}						
					}	
					else
					{
						break;
					}
					nErr = ISQLSTMT_Step(pThis->piStmt);
				}
				// in case there are some records less than required batch number
				if (nCounter > 0)
				{
					result = pMetaDBCallback(piMetaDB, nCounter, pIdArray, pUserData);
				}
				MetaFree(&pIdArray);
			}	
			IBASE_RELEASE_IPTR(pThis->piStmt);
		}
	}
	return result;
}


static int CMetaDB_Prepare_Result_With_List(CMetaDB* pThis, IAList* piList)
{
	int result = EFAILED, nErr;
	int id;
	int nCounter = 0;
	ushort nTextLen, nListSize, i;
	IMetaDB* piMetaDB = &pThis->myIMetaDB;
	
	if (IAList_GetSize(piList, &nListSize) == SUCCESS)
	{
		if (pThis->wzSQLText)
		{
			nTextLen = WSTRLEN(pThis->wzSQLText) * sizeof(AECHAR);

			if (SUCCESS == (result= ISQL_WPrepare(pThis->piSQL, pThis->wzSQLText, nTextLen, &pThis->piStmt, NULL)))
			{		
				for (i = 0; i < nListSize; i ++)
				{
					if (IAList_Get(piList, i, (void**)&id) == SUCCESS)
					{
						if (ISQLSTMT_BindInt(pThis->piStmt, 1, id) == SUCCESS)
						{
							if ((nErr = ISQLSTMT_Step(pThis->piStmt)) == SQL_DONE)
							{
								if (ISQLSTMT_Reset(pThis->piStmt) == SUCCESS)
								{
									nCounter ++;
								}
							}
						}
					}
					if (nCounter != i + 1)
					{
						// this means some error happens...
						break;
					}
				}
				IBASE_RELEASE_IPTR(pThis->piStmt);				
			}
		}
	}
	if (nCounter == nListSize)
	{
		result = SUCCESS;
	}
	return result;
}
static int CMetaDB_Prepare_Result(CMetaDB* pThis, IMetaDBRecord* pIMetaDBRecord, IAList* pIterate)
{
	int result = EFAILED, nErr;
	int id;
	ushort pos;
	int len;
	const AECHAR* pszPtr;

	len = WSTRLEN(pThis->wzSQLText) * sizeof(AECHAR);

	if (SUCCESS == (result= ISQL_WPrepare(pThis->piSQL, pThis->wzSQLText, len, &pThis->piStmt, &pszPtr)))
	{		
		if (pIMetaDBRecord)
		{
			MetaDB_Bind_Data(pThis, pIMetaDBRecord);
		}
		//SQL_ERROR			
		nErr = ISQLSTMT_Step(pThis->piStmt);
		if (pIterate != NULL)
		{				
			if (nErr == SQL_ROW)
			{	
				pos = 0;
				do
				{
					ISQLSTMT_GetColumnInt(pThis->piStmt, 0, &id);
					// treat int as if pointer !!! You must explain this to users!!! Nick
					IAList_Insert(pIterate, (TAListElement*)id, &pos);
					//try to insert at end of list ???
					pos ++; 

					nErr = ISQLSTMT_Step(pThis->piStmt);
				}
				while (nErr  == SQL_ROW);
				result = SUCCESS;							
			}
		}
		else
		{
			if (nErr == SQL_DONE || nErr == SQL_OK)
			{
				result = SUCCESS;
			}
		}
		IBASE_RELEASE_IPTR(pThis->piStmt);
	}	
	return result;
}

static int CMetaDB_IMetaDB_Create(IMetaDB *pIMetaDB, AECHAR* wzTableName, IMetaDBRecord* pIMetaDBRecord)
{
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	int result = EFAILED;

	if (pIMetaDB == NULL || wzTableName == NULL || pIMetaDBRecord == NULL)
	{
		return EBADPARM;
	}

	result = CMetaDB_Init(pIMetaDB, wzTableName);

	if (result != SUCCESS)
	{
		return result;
	}

	// TO DO:
	// we need to make a copy of IMetaDBRecord ...	

	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"create table %s(", wzTableName);

	MetaDB_Pack_String(pThis->wzSQLText, pIMetaDBRecord, MetaDB_Pack_Name_Type_Enum);

	WSTRCAT(pThis->wzSQLText, L")");
	
	return CMetaDB_Prepare_Result(pThis, NULL, NULL);
}

// this will only drop the table
static int CMetaDB_IMetaDB_Drop(IMetaDB *pIMetaDB)
{
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	int result = EFAILED;

	//we must assume the table is already opened!!
	//result = CMetaDB_Init(pIMetaDB, wzTableName);

	if (pThis->wzTableName == NULL || pThis->wzSQLText == NULL || pThis->piSQL == NULL)
	{
		return EBADPARM;
	}	
	// TO DO:
	// we need to make a copy of IMetaDBRecord ...	

	if (gpiDBCallBackList)
	{			
		result = MetaDB_RemoveCBPointer(pIMetaDB, gpiDBCallBackList);		
	}	
	else
	{
		result = SUCCESS;
	}

	if (result == SUCCESS)
	{
		WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"drop table %s", pThis->wzTableName);
		
		if ((result = CMetaDB_Prepare_Result(pThis, NULL, NULL)) == SUCCESS)
		{
			IBASE_RELEASE_IPTR(pThis->piSQL);		
		}
	}
	return result;
}

// destroy will delete the whole database file, but...
static int CMetaDB_IMetaDB_Destroy(IMetaDB* pIMetaDB)
{
	int result = EFAILED;
	CMetaDB* pThis = (CMetaDB*)pIMetaDB->pData;
	//CMetaDB_Destructor(pThis);

	IBASE_RELEASE_IPTR(pThis->piStmt); //release ISQLMgr .

	IBASE_RELEASE_IPTR(pThis->piSQL); //release ISQLMgr .


	if (gpiDBCallBackList)
	{			
		result = MetaDB_RemoveCBPointer(pIMetaDB, gpiDBCallBackList);		
	}	
	else
	{
		result = SUCCESS;
	}

	// nick :  this is dangerous because it is possible there are other user are using database at same time.
	result = ISQLMGR_Remove(pThis->piSQLMgr, "fs:/MetaDBFile");

	IBASE_RELEASE_IPTR(pThis->piSQLMgr); 

	return result;
}


static int CMetaDB_IMetaDB_Open(IMetaDB *pIMetaDB, AECHAR* wzTableName)
{
	//CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;	

	return  CMetaDB_Init(pIMetaDB, wzTableName);
	
}

// this is the method to create new dbrecord
static int CMetaDB_IMetaDB_New(IMetaDB *pIMetaDB, IMetaDBRecord** ppMetaDBRecord)
{
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	int result = EFAILED;
	return CMetaDBRecord_New(pThis->pIShell, META_CLSID_DBRECORD, ppMetaDBRecord);
}


static int CMetaDB_IMetaDB_Close(IMetaDB*pIMetaDB)
{	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	int result = EFAILED;	
	IBASE_RELEASE_IPTR(pThis->piSQL);

	IBASE_RELEASE_IPTR(pThis->piStmt);
	IBASE_RELEASE_IPTR(pThis->piSQLMgr);	
	
	if (pThis->wzTableName)
	{
		MetaFree(&pThis->wzTableName);
		pThis->wzTableName = NULL;
	}

	if (pThis->wzSQLText)
	{
		MetaFree(&pThis->wzSQLText);
		pThis->wzSQLText = NULL;
	}	

// TO DO:
	// need to cancel all registered event 	
	if (pThis->piCallbackList)
	{			
		MetaDB_RemoveCBPointer(pIMetaDB, pThis->piCallbackList);	
		IBASE_RELEASE_IPTR(pThis->piCallbackList);
	}	

	result = SUCCESS;	
	return result;
}


static int CMetaDB_IMetaDB_Join(IMetaDB *pILeftDB, IMetaDB *pIRightDB, AECHAR*pJoinRules,IMetaDB **ppIJointedDB)
{
	// NEED MORE EXPERIMENT BEFORE IMPLEMENT... NICK
	return EFAILED;
}

// therefore pQueryRules can be NULL
static int CMetaDB_IMetaDB_QuerySync(IMetaDB *pIMetaDB, AECHAR*pQueryRules, IAList* pIterate)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL || pThis->wzSQLText == NULL || pThis->piSQL == NULL)
	{
		return result;
	}	
	
	if (pQueryRules)
	{
		WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"select id from %s where %s", pThis->wzTableName, pQueryRules);	
	}
	else
	{
		WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"select id from %s", pThis->wzTableName);	
	}

	result = CMetaDB_Prepare_Result(pThis, NULL, pIterate);	

	return result;	

}


// next step we should try to use AECHAR
// note : field id can be any number, record id is stored in a field named " id"
static int CMetaDB_IMetaDB_Insert(IMetaDB *pIMetaDB, IMetaDBRecord* pIMetaDBRecord)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL ||pThis->wzSQLText == NULL || pIMetaDBRecord == NULL||pThis->piSQL == NULL)
	{
		return result;
	}	
	
	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"insert into %s(", pThis->wzTableName);

	MetaDB_Pack_String(pThis->wzSQLText, pIMetaDBRecord, MetaDB_Pack_Name_Enum);
	
	WSTRCAT(pThis->wzSQLText,L")values(");

	MetaDB_Pack_String(pThis->wzSQLText, pIMetaDBRecord, MetaDB_Pack_WildCard_Enum);	
	
	WSTRCAT(pThis->wzSQLText, L")");
	
	result = CMetaDB_Prepare_Result(pThis, pIMetaDBRecord, NULL);	
	if (result == SUCCESS)
	{
		CMetaDB_Notify_Event(pIMetaDB, META_DB_EVENT_INSERTED);
	}
	return result;	
}


static int CMetaDB_IMetaDB_Delete(IMetaDB *pIMetaDB, int id)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL ||pThis->wzSQLText == NULL ||pThis->piSQL == NULL)
	{
		return result;
	}	
	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"delete from %s where id= %d", pThis->wzTableName, id);
	
	result =  CMetaDB_Prepare_Result(pThis, NULL, NULL);	
	if (result == SUCCESS)
	{
		CMetaDB_Notify_Event(pIMetaDB, META_DB_EVENT_DELETED);
	}
	return result;	
}

static int CMetaDB_IMetaDB_DeleteAll(IMetaDB *pIMetaDB)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL ||pThis->wzSQLText == NULL ||pThis->piSQL == NULL)
	{
		return result;
	}		
	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"delete from %s", pThis->wzTableName);
	
	result =  CMetaDB_Prepare_Result(pThis, NULL, NULL);	
	if (result == SUCCESS)
	{
		CMetaDB_Notify_Event(pIMetaDB, META_DB_EVENT_DELETED);
	}
	return result;	
}

static int CMetaDB_IMetaDB_Update(IMetaDB *pIMetaDB, int id, IMetaDBRecord* pIMetaDBRecord)
{	
	int result = EFAILED;
	AECHAR* wzPtr;
	int len;
	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL ||pThis->wzSQLText == NULL || pIMetaDBRecord == NULL ||pThis->piSQL == NULL)
	{
		return result;
	}	
	
	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"update %s set ", pThis->wzTableName);
	
	MetaDB_Pack_String(pThis->wzSQLText, pIMetaDBRecord, MetaDB_Pack_Assignment_Enum);
	len = WSTRLEN(pThis->wzSQLText);
	wzPtr = pThis->wzSQLText + len;
	WSPRINTF(wzPtr, Max_Meta_Sql_Text_Length - len, L" where id=%d", id);	

	result = CMetaDB_Prepare_Result(pThis, pIMetaDBRecord, NULL);	
	if (result == SUCCESS)
	{
		CMetaDB_Notify_Event(pIMetaDB, META_DB_EVENT_UPDATED);
	}
	return result;	
}

// to do : nick this is half-finished.
static int CMetaDB_IMetaDB_Get(IMetaDB *pIMetaDB, int rowId, IMetaDBRecord** ppIMetaDBRecord)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL ||pThis->wzSQLText == NULL || ppIMetaDBRecord== NULL ||pThis->piSQL == NULL)
	{
		return result;
	}	
	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"select * from %s where id=%d", pThis->wzTableName, rowId);

	// we need a new method to get result of single row.
	if (CMetaDBRecord_New(pThis->pIShell, META_CLSID_DBRECORD, ppIMetaDBRecord) == SUCCESS) 
	{
		result = CMetaDB_Prepare_Result_For_One_Row(pThis, *ppIMetaDBRecord);
	}
	
	return result;
}

static int CMetaDB_IMetaDB_RegisterStatusChanged(IMetaDB *pIMetaDB, MetaDBStatusChangedFunc pMetaDBStatusChangedCB, MetaDBStatusMark statusEventMark,void* userData)
{
	int result = EFAILED;	
	ushort pos;
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	DBManagerData* pDBManagerData;
	if (pMetaDBStatusChangedCB == NULL)
	{
		//this is an error.
		return EBADPARM;
	}
	if (SUCCESS == MetaDB_GetCBPointer(pIMetaDB, gpiDBCallBackList, &pDBManagerData))
	{
		// this is just update previous registered event callback
		pDBManagerData->pCB = pMetaDBStatusChangedCB;
		pDBManagerData->statusEventMark = statusEventMark;
		pDBManagerData->userData = userData;
		result = SUCCESS;
	}
	else
	{	
		//here we actually register new event
		pDBManagerData = MetaAlloc(sizeof(DBManagerData));
		if (pDBManagerData == NULL)
		{
			return ENOMEMORY;
		}
		pDBManagerData->pAppContext = AEE_GetAppContext();
		pDBManagerData->pCB = pMetaDBStatusChangedCB;
		pDBManagerData->pIDB = pIMetaDB;
		pDBManagerData->pTabelName = CMetaDB_GetTableName(pIMetaDB);
		pDBManagerData->statusEventMark = statusEventMark;
		pDBManagerData->userData = userData;			
		result = IAList_Insert(gpiDBCallBackList, (TAListElement*)pDBManagerData, &pos);
	}
	return result;
}

static int CMetaDB_IMetaDB_GetCount(IMetaDB* pIMetaDB, AECHAR* wzFilterRule, int* nRecCount)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL ||pThis->wzSQLText == NULL || pThis->piSQL == NULL)
	{
		return result;
	}	
	if (wzFilterRule)
	{
		WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"select count(id) from %s where %s", pThis->wzTableName, wzFilterRule);
	}
	else
	{
		WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"select count(id) from %s", pThis->wzTableName);
	}


	result = CMetaDB_Prepare_Result_For_int(pThis, nRecCount);
	
	return result;
}

static int CMetaDB_IMetaDB_Query(IMetaDB *pIMetaDB, AECHAR*pQueryRules, MetaDBCallBack pMetaDBCallback, int nRecNumber, void* pUserData)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL || pThis->wzSQLText == NULL || pThis->piSQL == NULL)
	{
		return result;
	}	
	
	if (pQueryRules)
	{
		WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"select id from %s where %s", pThis->wzTableName, pQueryRules);	
	}
	else
	{
		WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"select id from %s", pThis->wzTableName);	
	}

	result = CMetaDB_Prepare_Result_With_Callback(pThis, pMetaDBCallback, nRecNumber, pUserData);
	
	return result;	
}

static int CMetaDB_IMetaDB_DeleteList(IMetaDB*pIMetaDB, IAList* piList)
{
	int result = EFAILED;	
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	
	if (pThis->wzTableName == NULL || pThis->wzSQLText == NULL || pThis->piSQL == NULL || piList == NULL)
	{
		return EBADPARM;
	}	
	
	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"delete from %s where id=?1;", pThis->wzTableName);	

	if (CMetaDB_IMetaDB_BeginTransaction(pIMetaDB) == SUCCESS)
	{
		result = CMetaDB_Prepare_Result_With_List(pThis, piList);
		CMetaDB_IMetaDB_EndTransaction(pIMetaDB);
	}
	return result;
}



static int CMetaDB_IMetaDB_BeginTransaction(IMetaDB *pIMetaDB)
{
	int result = EFAILED;
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	if (pThis)
	{
		if (pThis->piSQL)
		{
			result = ISQL_Exec(pThis->piSQL, "Begin Transaction;", NULL, NULL, NULL);		
		}
	}
	return result;
}


static int CMetaDB_IMetaDB_EndTransaction(IMetaDB *pIMetaDB)
{
	int result = EFAILED;
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	if (pThis)
	{
		if (pThis->piSQL)
		{
			result = ISQL_Exec(pThis->piSQL, "End Transaction;", NULL, NULL, NULL);		
		}
	}
	return result;
}

static int CMetaDB_IMetaDB_AddIndex(IMetaDB *pIMetaDB, int nFieldId)
{
	int result = EFAILED;
	CMetaDB* pThis = (CMetaDB* )pIMetaDB->pData;
	if (nFieldId < 0 || pThis->wzSQLText == NULL || pThis->wzTableName == NULL)
	{
		return EBADPARM;
	}

	WSPRINTF(pThis->wzSQLText, Max_Meta_Sql_Text_Length, L"create index if not exists field%dIndex on %s (field%d);", nFieldId, pThis->wzTableName, nFieldId);	
	result = CMetaDB_Prepare_Result(pThis, NULL, NULL);
	return result;
}


/*=====================================================================

  INTERFACE  DOCUMENTATION

=======================================================================


Interface Name: IMetaDB


==============================================================================
Method:  IMetaDB_Create()

Description:This method places a data element at the end of the list collection.

Prototype:  unit32 IAList_Add(IMetaDB *pIMetaDB, AECHAR* wzTableName, IMetaDBRecord* pIMetaDBRecord)
            pIMetaDB         in
            wzTableName      in
			pIMetaDBRecord   in
            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 ENOMEMORY - EFAILED
	 EBADPARM  - parameter is error
	 SQL_ERROR 

==============================================================================
Method:  IMetaDB_Drop()

Description: This method drops opened table by using sql "drop table" after 'callback events" are
successfully removed. 

I observe the table may be locked by sqlite and proceeding query can still access data in table. 

 
Prototype:	unit32 IMetaDB_Drop(IMetaDB *pIMetaDB)
			pIMetaDB     in
					
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
	EFAILED
==============================================================================
Method:  IMetaDB_Destroy()

Description:This method removes database file after successfully removes all registered callback events. And also 
closes sqlmanager interface ISQLMgr which is associated with the database file.

Prototype:	unit32 IMetaDB_Destroy(IMetaDB *pIMetaDB)
			pIMetaDB     in
					
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
	EFAILED
==============================================================================
Method:  IMetaDB_Open()

Description:This method opens table with specified table name and does some initialization. It does NOT
check if the table exists.

Prototype:	unit32 IMetaDB_Open(IMetaDB *pIMetaDB, AECHAR* wzTableName);
			pIMetaDB     in
			wzTableName  in
					
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
==============================================================================

Method:  IMetaDB_Close()

Description:This method close table without droping the table after successfully removing registered events. 

Prototype:	unit32 IMetaDB_Close(IMetaDB *pIMetaDB);
			pIMetaDB     in
					
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
==============================================================================

Method:  IMetaDB_Query()

Description:This method query an opened table with specified filter conditions(can be NULL if no filter needed). 
The callback function supplied by user will be called with speicified records' "id" stored in an integer array 
plus user-supplied data parameter.

Prototype:	unit32 IMetaDB_Query(IMetaDB *pIMetaDB, AECHAR*pQueryRules, MetaDBCallBack pMetaDBCallBack, int nRecNumber, void* pUserData);
			pIMetaDB          in
			pQueryRules       in (user supplied filter condition and can be NULL if none filter needed)
			pMetaDBCallBack   in (is a placeholder of user-defined callback)
			nRecNumber        in (is number of records required to be collected for callback) 
			pUserData         in (user-defined parameter for callback)
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
////////////////////////////////////////////////////////////////////////////////////////////////////////////
Prototype of callback: int MetaDBCallBack(IMetaDB* pIMetaDB, int nRecNumber, int* pIdArray, void* pUserData); 
			pIMetaDB         in
			nRecNumber       in (number of records' id in pIdArray)
			pIdArray         in (an array of integer contains "id" of result of query)
			pUserData        in (user data passed in query)
Return Value:
	if NOT return SUCCESS, then the query will stop calling further callbacks and stops.			
==============================================================================

  Method:  IMetaDB_QuerySync()

Description:This method query an opened table with specified filter conditions(can be NULL if no filter needed). 
The IAList supplied by user will be populated with records' "id".

Prototype:	unit32 IMetaDB_QuerySync(IMetaDB *pIMetaDB, AECHAR*pQueryRules, IAList* pIterate);
			pIMetaDB          in
			pQueryRules       in (user supplied filter condition and can be NULL if none filter needed)
			pIterate          in (user-supplied list to hold "id" of result records)
			
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================

  Method:  IMetaDB_Insert()

Description:This method inserts a single record in an opened table by user supplied IMetaDBRecord

Prototype:	unit32 IMetaDB_Insert(IMetaDB *pIMetaDB, IMetaDBRecord* pIMetaDBRecord);
			pIMetaDB          in
			pIMetaDBRecord    in (user supplied data container)
			
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================


  Method:  IMetaDB_Delete()

Description:This method deletes one record by specified record id

Prototype:	unit32 IMetaDB_Delete(IMetaDB *pIMetaDB,int id);
			pIMetaDB          in
			id                in (id of record to be deleted)
			
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================
  
  Method:  IMetaDB_DeleteAll()

Description:This method deletes all records in an opened table

Prototype:	unit32 IMetaDB_DeleteAll(IMetaDB *pIMetaDB);
			pIMetaDB          in
			
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================

  Method:  IMetaDB_Update()

Description:This method deletes all records in an opened table

Prototype:	unit32 IMetaDB_Update(IMetaDB *pIMetaDB,int id, IMetaDBRecord* pIMetaDBRecord);
			pIMetaDB          in
			pIMetaDBRecord    in (user supplied data container)
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================

  Method:  IMetaDB_Get()

Description:This method retrieve one record with specified id and stored in IMetaDBRecord. User is responsible to
release IMetaDBRecord.

Prototype:	unit32 IMetaDB_Get(IMetaDB *pIMetaDB, int rowId, IMetaDBRecord** ppIMetaDBRecord);
			pIMetaDB          in
			ppIMetaDBRecord   out (user is responsible to release)
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================

  Method:  IMetaDB_GetCount()

Description:This method retrieve the number of records in opened table

Prototype:	unit32 IMetaDB_GetCount(IMetaDB* pIMetaDB, AECHAR* wzFilterRule, int* nRecCount);
			pIMetaDB          in
			wzFilterRule      in (user supplied filter condition, can be NULL if no filter needed)
			nRecCount         out(number of records in table) 
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================

  Method:  IMetaDB_RegisterStatusChanged()

Description:This method registers a a user callback with specified event. The statusEventMark current includes three
kinds of event type: insert, delete, update in bit-mask format. User can use "META_DB_EVENT_ALL" to specify all events.
Currently we do NOT allow callback to be notified with its own IMetaDB.  

For example, IMetaDB1 may register a callback
with table1, event of "update", then if IMetaDB2's update operation will execute this callback after its successful update
operation. However, IMetaDB1's update operation won't cause its registered callback to be executed.

Prototype:	unit32 IMetaDB_RegisterStatusChanged(IMetaDB *pIMetaDB, MetaDBStatusChangedFunc pMetaDBStatusChangedCB,MetaDBStatusMark statusEventMark,void* pUserData);
			pIMetaDB                    in
			pMetaDBStatusChangedCB      in (placeholder for user defined callback)
			statusEventMark             in (interested status) 
			pUserData                   in (user'd defined param data)
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================
 

  Method:  IMetaDB_BeginTransaction()

Description: This method starts a transaction in sqlite. It is particular useful when large number of operations are executed
in batch. As sqlite will treat each "write" db operation as a default transaction, it is extremely slow to maintain
transaction logging operation. Therefore, this interface method treat all following operation as one single transaction 
until "endtransaction" method is called. Experiment shows it will make large number of "write" operation much, much faster.


Prototype:	unit32 IMetaDB_BeginTransaction(IMetaDB *pIMetaDB);
			pIMetaDB                    in
	
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================

  Method:  IMetaDB_EndTransaction()

Description: This method ends a transaction in sqlite. It is particular useful when large number of operations are executed
in batch. As sqlite will treat each "write" db operation as a default transaction, it is extremely slow to maintain
transaction logging operation. Therefore, this interface method treat all following operation as one single transaction 
until "endtransaction" method is called. Experiment shows it will make large number of "write" operation much, much faster.


Prototype:	unit32 IMetaDB_EndTransaction(IMetaDB *pIMetaDB);
			pIMetaDB                    in
	
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EBADPARM  - parameter is error
		EFAILED
=============================================================================

*/	


